<realtimedatatables>
    <link type="text/css" rel="stylesheet" href="assets/styles/realtime.css">
    <div class="panel-body assetList">
        <div class="table-responsive">
            <table id="{props.name}_gpsdatatables" class="table gpsTable" role="grid" width="100%" cellspacing="0">
                <thead>
                <th><input type="checkbox" name="allCheck"></th>
                <th each="{item in props.items}">
                    <span style="margin-right: 5px;">{item}</span>
                    (
                    <span id="c-page"></span>
                    <span>/</span>
                    <span id="t-page"></span>
                    )
                </th>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>
    <script>

        export default {
            onMounted(props, state) {
                if (!props.name) return
                this.name = props.name

                var self = this
                $.getJSON('assets/json/datatables/' + props.name + '.json').then(function(json, status) {
                    Function.prototype.toJSON = Function.prototype.toString
                    var parser = function(k,v){return v.toString().indexOf('function') === 0 ? eval('('+v+')') : v}
                    var jsonText = JSON.stringify(json)
                    var data = JSON.parse(jsonText, parser)
                    if (props.addJSON) {
                        data = props.addJSON(json)
                    }
                    self.buildDataTables(props, data, props.service)
                })
            },
            buildDataTables(props, data, service) {
                var dataTable = $('#' + props.name + '_gpsdatatables').DataTable({
                    dom: 'ftp',
                    initComplete: function (datatable, data) {
                        if (props.initComplete) props.initComplete(datatable, data)
                    },
                    ajax: function (data, callback, settings) {
                        if (props.ajax) {

                            props.ajax(function(json) {
                                callback({
                                    data:json
                                })
                            })
                            return
                        }
                    },
                    rowCallback: function (row, data, rowNo) {
                        if (props.rowCallback) return props.rowCallback(row, data, rowNo)
                    },
                    retrieve: true,
                    destroy: true,
                    columns: data.columns,
                    ordering: false,
                    sortable: false,
                    stateSave: false,
                    processing: true,
                    loadingRecords : true,
                    scrollCollapse: true,
                    scrollX: true,
                    autoWidth: false,
                    pagingType: "full",
                    language: {
                        lengthMenu: '表示件数 _MENU_',
                        search: '<div class="input-group"><span class="input-group-addon"><span class="glyphicon glyphicon-search" style="padding-left:10px;"></span></span>',
                        searchPlaceholder: '検索文字列を入力',
                        select: {
                            rows: {
                                _: "%d件選択中",
                                0: '',
                                1: "1件選択中"
                            }
                        },
                        zeroRecords: '検索結果は0件',
                        info: ' _TOTAL_ 件中 _START_ から _END_ まで表示',
                        infoFiltered: '全_MAX_件から検索',
                        infoEmpty:'',
                        paginate: {
                            sFirst:    '最初',
                            sPrevious: '前へ',
                            sNext:     '次へ',
                            sLast:     '最後'
                        }
                    }
                })

                // レイアウト
                $('.dataTables_filter ').addClass('pull-left input-group')
                $('.dataTables_filter input').addClass("search_type form-control searchBox")
                $('.dataTables_filter input').css('margin-left','10px')
                $('.dataTables_filter input').css('width','225px')


                $('.pagination').addClass('pgsPage')

                if (props.numberLines) props.numberLines(dataTable)

                dataTable.on('draw', function () {
                    const info = $("#gpslist_gpsdatatables").dataTable().api().page.info()
                    $('#c-page').text(info.page + 1)
                    $('#t-page').text(info.pages)
                    if (props.draw) props.draw()
                })


            }

        }

    </script>
</realtimedatatables>
